/// @cond EO_CXX_EO_IMPL

inline bool elm::container::content_set(::efl::eina::string_view name_, ::evas::object content_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_container_content_set(::efl::eolian::to_c(name_), ::efl::eolian::to_c(content_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::evas::object elm::container::content_get(::efl::eina::optional< ::efl::eina::string_view > name_) const
{
   Evas_Object * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_container_content_get(::efl::eolian::to_c(name_)));
   return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::evas::object elm::container::content_unset(::efl::eina::optional< ::efl::eina::string_view > name_) const
{
   Evas_Object * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_container_content_unset(::efl::eolian::to_c(name_)));
   return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::efl::eina::list< ::evas::object > elm::container::content_swallow_list_get() const
{
   Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_container_content_swallow_list_get());
   return ::efl::eolian::to_cxx<::efl::eina::list< ::evas::object >>(_tmp_ret, std::tuple<std::true_type, std::false_type>());
}

inline bool eo_cxx::elm::container::content_set(::efl::eina::string_view name_, ::evas::object content_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_container_content_set(::efl::eolian::to_c(name_), ::efl::eolian::to_c(content_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::evas::object eo_cxx::elm::container::content_get(::efl::eina::optional< ::efl::eina::string_view > name_) const
{
   Evas_Object * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_container_content_get(::efl::eolian::to_c(name_)));
   return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::evas::object eo_cxx::elm::container::content_unset(::efl::eina::optional< ::efl::eina::string_view > name_) const
{
   Evas_Object * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_container_content_unset(::efl::eolian::to_c(name_)));
   return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::efl::eina::list< ::evas::object > eo_cxx::elm::container::content_swallow_list_get() const
{
   Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_container_content_swallow_list_get());
   return ::efl::eolian::to_cxx<::efl::eina::list< ::evas::object >>(_tmp_ret, std::tuple<std::true_type, std::false_type>());
}

inline ::eo_cxx::elm::container::operator ::elm::container() const
{
   return *static_cast<::elm::container const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::container::operator ::elm::container&()
{
   return *static_cast<::elm::container*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::container::operator ::elm::container const&() const
{
   return *static_cast<::elm::container const*>(static_cast<void const*>(this));
}

template <typename T>
bool elm_container_content_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * name_, Evas_Object * content_)
{
   try
      {
         return static_cast<T*>(self->this_)->content_set(::efl::eolian::to_cxx<::efl::eina::string_view>(name_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::evas::object>(content_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::evas::object elm_container_content_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * name_)
{
   try
      {
         return static_cast<T*>(self->this_)->content_get(::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(name_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Evas_Object * _tmp_ret{};
         return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::evas::object elm_container_content_unset_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * name_)
{
   try
      {
         return static_cast<T*>(self->this_)->content_unset(::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(name_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Evas_Object * _tmp_ret{};
         return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::efl::eina::list< ::evas::object > elm_container_content_swallow_list_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->content_swallow_list_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_List * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::list< ::evas::object >>(_tmp_ret, std::tuple<std::true_type, std::false_type>());
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::container >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::widget >::template type<T>
   {
      virtual bool content_set(::efl::eina::string_view name_, ::evas::object content_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_container_content_set(::efl::eolian::to_c(name_), ::efl::eolian::to_c(content_)));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::evas::object content_get(::efl::eina::optional< ::efl::eina::string_view > name_)
      {
         Evas_Object * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_container_content_get(::efl::eolian::to_c(name_)));
            return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::evas::object content_unset(::efl::eina::optional< ::efl::eina::string_view > name_)
      {
         Evas_Object * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_container_content_unset(::efl::eolian::to_c(name_)));
            return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::efl::eina::list< ::evas::object > content_swallow_list_get()
      {
         Eina_List * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_container_content_swallow_list_get());
            return ::efl::eolian::to_cxx<::efl::eina::list< ::evas::object >>(_tmp_ret, std::tuple<std::true_type, std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::elm::container >
{
   static constexpr int value = 
#if defined(CONTAINER_PROTECTED) && defined(CONTAINER_BETA)
      4
#elif defined(CONTAINER_PROTECTED)
      4
#elif defined(CONTAINER_BETA)
      4
#else
      4
#endif
      + operation_description_class_size<::elm::widget >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::container>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_container_content_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_container_content_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_container_content_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_container_content_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_container_content_unset_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_container_content_unset);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_container_content_swallow_list_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_container_content_swallow_list_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::widget>(), &ops[operation_description_class_size< ::elm::container >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::container>)
{
   return (ELM_CONTAINER_CLASS);
}

} } }

/// @endcond

